net.sf.cpsolver.studentsct.heuristics

## Class StudentSctNeighbourSelection

- java.lang.Object
- - net.sf.cpsolver.ifs.heuristics.StandardNeighbourSelection<V,T>
  - - net.sf.cpsolver.ifs.heuristics.RoundRobinNeighbourSelection<Request,Enrollment>
    - - net.sf.cpsolver.studentsct.heuristics.StudentSctNeighbourSelection

- All Implemented Interfaces:
    NeighbourSelection<Request,Enrollment>
  Direct Known Subclasses:
    TwoPhaseStudentSctNeighbourSelection

      public class StudentSctNeighbourSelection
      extends RoundRobinNeighbourSelection<Request,Enrollment>

  (Batch) student sectioning neighbour selection. It is based on `RoundRobinNeighbourSelection`, the following steps are involved:
  - Phase 1: section all students using incremental branch & bound (no unassignments) (`BranchBoundSelection` is used)
  - Phase 2: pick a student (one by one) with an incomplete schedule, try to find an improvement (`SwapStudentSelection` is used)
  - Phase 3: use standard value selection for some time ( `StandardSelection` is used)
  - Phase 4: use backtrack neighbour selection (`BacktrackSelection` is used)
  - Phase 5: pick a student (one by one) with an incomplete schedule, try to find an improvement, identify problematic students ( `SwapStudentSelection` is used)
  - Phase 6: random unassignment of some problematic students ( `RndUnProblStudSelection` is used)
  - Phase 7: resection incomplete students ( `ResectionIncompleteStudentsSelection` is used)
  - Phase 8: resection of students that were unassigned in step 6 ( `ResectionUnassignedStudentsSelection` is used)
  - Phase 9: pick a student (one by one) with an incomplete schedule, try to find an improvement (`SwapStudentSelection` is used)
  - Phase 10: use standard value selection for some time ( `StandardSelection` with `RouletteWheelRequestSelection` is used)
  - Phase 11: pick a student (one by one) with an incomplete schedule, try to find an improvement (`SwapStudentSelection` is used)
  - Phase 12: use backtrack neighbour selection (`BacktrackSelection` is used)
  - Phase 13: random unassignment of some students ( `RandomUnassignmentSelection` is used)
  Version:
    StudentSct 1.2 (Student Sectioning)
    Copyright (C) 2007 - 2010 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `StudentSctNeighbourSelection(DataProperties properties)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `changeSelection(Solution<Request,Enrollment> solution)` Change selection
    `void` | `init(Solver<Request,Enrollment> solver)` Initialization
    `void` | `setup(Solver<Request,Enrollment> solver)`

    - ### Methods inherited from class net.sf.cpsolver.ifs.heuristics.RoundRobinNeighbourSelection

      `registerSelection, selectNeighbour`

    - ### Methods inherited from class net.sf.cpsolver.ifs.heuristics.StandardNeighbourSelection

      `getValueSelection, getVariableSelection, selectValue, selectVariable, setValueSelection, setVariableSelection`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### StudentSctNeighbourSelection

          public StudentSctNeighbourSelection(DataProperties properties)
                                       throws Exception

      Throws:
        `Exception`

  - ### Method Detail

    - #### init

          public void init(Solver<Request,Enrollment> solver)

      Description copied from class: `RoundRobinNeighbourSelection`
      Initialization
      Specified by:
        `init` in interface `NeighbourSelection<Request,Enrollment>`
      Overrides:
        `init` in class `RoundRobinNeighbourSelection<Request,Enrollment>`

    - #### setup

          public void setup(Solver<Request,Enrollment> solver)

    - #### changeSelection

          public void changeSelection(Solution<Request,Enrollment> solution)

      Description copied from class: `RoundRobinNeighbourSelection`
      Change selection
      Overrides:
        `changeSelection` in class `RoundRobinNeighbourSelection<Request,Enrollment>`